/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = function(fktRandomInt) {
    function getUniqueValues(count, min, max) {
        const values = [];
        while (values.length < count) {
            const randomValue = fktRandomInt(min, max - values.length);
            values.push(values.slice().sort((a, b) => a - b).reduce((newValue, oldValue) => ((newValue >= oldValue) ? (newValue + 1) : newValue), randomValue));
        }
        return values;
    }

    const varType = 'int';
    const varNames = getUniqueValues(3, 'a'.charCodeAt(0), 'z'.charCodeAt(0)).map(code => String.fromCharCode(code));
    const varValues = getUniqueValues(2, 1, 9);
    const tmpValuesIndex = fktRandomInt(0, 1);
    const tmpIntroduction = fktRandomInt(0,  2);
    const tmpName = varNames[2];

    const result = {
        task: 'Führe den Code aus, indem du immer die Auswirkungen der hervorgehobenen Zeile in der Speichertabelle einträgst und die nächste auszuführende Codezeile auswählst.',
        code: '',
        steps: [
            { line: -1, vars: [], task: '<p>Überlege zuerst: Was müsste das Programm insgesamt bewirken? Und welche Rolle spielt dabei die Variable <code>' + varNames[2] + '</code>?</p><p>Trage nichts in die Speichertabelle ein und wähle die allererste Anweisung aus, um mit der schrittweisen Ausführung zu beginnen. So kannst du deine Vermutung überprüfen.</p>' }
        ]
    }

    function eventuallyAddTmpIntroduction(pos) {
        if (pos != tmpIntroduction)
            return;
        result.code += (tmpIntroduction ? '\n' : '') + varType + ' ' + varNames[2] + ';' + (tmpIntroduction ? '' : '\n');
        const step = { line: (result.code.match(/\n/g) || []).length + (tmpIntroduction ? 1 : 0), vars: [ { key: varNames[2], value: 0, type: varType } ] };
        if (tmpIntroduction >= 1)
            step.vars.push({ key: varNames[0], value: varValues[0], type: varType });
        if (tmpIntroduction >= 2)
            step.vars.push({ key: varNames[1], value: varValues[1], type: varType });
        result.steps.push(step);
    }

    function eventuallyAddTmpVar(pos) {
        if (pos < tmpIntroduction)
            return;
        result.steps[result.steps.length - 1].vars.push({ key: varNames[2], value: 0, type: varType });
    }

    result.steps.push({
        task: result.task,
        line: 0
    });

    eventuallyAddTmpIntroduction(0);
    result.code += varType + ' ' + varNames[0] + ' = ' + varValues[0] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: varValues[0], type: varType } ]
    });
    eventuallyAddTmpVar(0);

    eventuallyAddTmpIntroduction(1);
    result.code += '\n' + varType + ' ' + varNames[1] + ' = ' + varValues[1] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: varValues[0], type: varType }, { key: varNames[1], value: varValues[1], type: varType } ]
    });
    eventuallyAddTmpVar(1);

    eventuallyAddTmpIntroduction(2);

    result.code += '\n' + varNames[2] + ' = ' + varNames[tmpValuesIndex] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [
            { key: varNames[0], value: varValues[0], type: varType },
            { key: varNames[1], value: varValues[1], type: varType },
            { key: varNames[2], value: varValues[tmpValuesIndex], type: varType }
        ]
    });

    result.code += '\n' + varNames[tmpValuesIndex] + ' = ' + varNames[1 - tmpValuesIndex] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [
            { key: varNames[0], value: varValues[1 - tmpValuesIndex], type: varType },
            { key: varNames[1], value: varValues[1 - tmpValuesIndex], type: varType },
            { key: varNames[2], value: varValues[tmpValuesIndex], type: varType }
        ]
    });

    result.code += '\n' + varNames[1 - tmpValuesIndex] + ' = ' + varNames[2] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [
            { key: varNames[0], value: varValues[1], type: varType },
            { key: varNames[1], value: varValues[0], type: varType },
            { key: varNames[2], value: varValues[tmpValuesIndex], type: varType }
        ]
    });

    result.steps[result.steps.length - 1].line = Infinity;
    result.steps[result.steps.length - 1].task = '<p>Dank der zusätzlichen Variable <code>' + tmpName + '</code> gelingt also der Wertetausch: Nun hat <code>' + varNames.filter(key => (key != tmpName)).join('</code> als Wert den Startwert von <code>') + '</code> und umgekehrt.</p><p>Klicke zum Abschließen erneut auf „Fertig“!</p>';
    result.steps.push({ line: Infinity });

    // Variablen sortieren
    varNames.splice(tmpIntroduction, 0, varNames.pop());
    result.steps.forEach(step => {
        if (step.vars instanceof Array)
            step.vars.sort((a, b) => (varNames.indexOf(a.key) - varNames.indexOf(b.key)));
    });

    return result;
};
